<template>
  <div>
    <div v-if="!mapView">
      <q-card
        class="listCard"
        bordered
        :style="this.style"
      >
        <q-card-section
          class="section"
          v-if="patientId > -1"
          clickable
          v-ripple
          @click="patientDetail($router, patientId, roomNumber, dept)"
        >
          <div class="container">
            <div v-if="configData.showPic">
              <q-avatar
                size="60px"
                v-if="this.patient.picture !==''"
              >
                <img
                  :src='"http://localhost:3000/" + this.patient.picture'
                  alt=""
                >
              </q-avatar>
              <q-avatar
                v-else
                color="grey"
                size="60px"
              >
                {{this.patient.name.charAt(0)}}
              </q-avatar>
            </div>
            <q-avatar
              v-else
              color="grey"
              size="60px"
            >
              {{this.patient.name.charAt(0)}}
            </q-avatar>
            <div>
              <q-item-label class="text-h6">{{ this.patient.name }}</q-item-label>
              <q-item-label
                v-if="configData.showNumber"
                class="text-subtitle"
              >Room: {{ dept.floor }}.{{ roomNumber }}</q-item-label>
              <div v-if="configData.showMonitoring">
                <q-icon name="favorite_border"></q-icon>
                {{ this.patient.heartrate }}
                &emsp;
                <q-icon name="fas fa-heartbeat"></q-icon>
                {{ this.patient.bloodpressure }}
              </div>
            </div>
          </div>
        </q-card-section>

        <q-card-section
          class="section"
          v-else
        >
          <div
            v-if="configData.showNumber"
            class="text-h6"
          >Room: {{dept.floor}}.{{ roomNumber }}</div>
        </q-card-section>

        <q-separator />

        <q-card-section
          class="section"
          v-if="patientId > -1"
          clickable
          v-ripple
          @click="finishAction(nextAction)"
        >
          <div v-if="configData.showNextAction">
            <div class="text-h6">Next action</div>
            <div>
              <p>{{new Date(nextAction.time).toLocaleString('en-GB')}}</p>
              <p>{{nextAction.type}}</p>
            </div>
          </div>
        </q-card-section>

        <q-card-section
          class="section"
          v-if="patientId === -1"
        >
          <q-btn
            id="addBtn"
            round
            fab
          >
            <q-icon name="add"></q-icon>
          </q-btn>
        </q-card-section>

        <q-separator />

        <q-card-section
          class="section"
          clickable
          v-ripple
          v-if="configData.showFacilities"
          @click="() => {
        this.calledHelp = true
        this.styling(this.patientId, this.nextAction.time, this.patient.heartrate, this.patient.bloodpressure)
        }"
        >
          <div class="text-h6">Facilities</div>
          <div class="facilities">
            <div
              class="facility"
              v-for="(item, index) in facilities"
              :key="index"
            >
              <q-icon :name='"fas fa-" + item'></q-icon>
            </div>
          </div>
        </q-card-section>
        <audio
          v-if="configData.alarm && configData.heartrate.lower >= this.patient.heartrate || this.patient.heartrate >= configData.heartrate.upper ||
          this.patient.bloodpressure <= configData.bloodpressure.lower || this.patient.bloodpressure >= configData.bloodpressure.upper"
          autoplay
          loop
        >
          <source
            src="../assets/alert.wav"
            type="audio/wav"
          >
        </audio>
      </q-card>
    </div>
    <div v-if="mapView">
      <div>
        <q-card
          bordered
          class="mapCard"
          :style="{width: width + 'px', height: length + 'px',
           left: x + 'px', top: y + 'px',
           ...this.style}"
        >
          <q-card-section
            class="mapSection"
            v-if="patientId > -1"
            clickable
            v-ripple
            @click="patientDetail($router, patientId, roomNumber, dept)"
          >
            <div class="container">
              <div v-if="configData.showPic">
                <q-avatar
                  size="60px"
                  v-if="this.patient.picture !==''"
                >
                  <img
                    :src='"http://localhost:3000/" + this.patient.picture'
                    alt=""
                  >
                </q-avatar>
                <q-avatar
                  v-else
                  color="grey"
                  size="60px"
                >
                  {{this.patient.name.charAt(0)}}
                </q-avatar>
              </div>
              <q-avatar
                v-else
                color="grey"
                size="60px"
              >
                {{this.patient.name.charAt(0)}}
              </q-avatar>
              <div>
                <q-item-label><b>{{ this.patient.name }}</b></q-item-label>
                <q-item-label
                  v-if="configData.showNumber"
                  class="text-subtitle"
                >Room: {{ dept.floor }}.{{ roomNumber }}</q-item-label>
                <div v-if="configData.showMonitoring">
                  <q-icon name="favorite_border"></q-icon>
                  {{ this.patient.heartrate }}
                  &emsp;
                  <q-icon name="fas fa-heartbeat"></q-icon>
                  {{ this.patient.bloodpressure }}
                </div>
              </div>
            </div>
          </q-card-section>
          <q-card-section
            class="section"
            v-else
          >
            <div
              v-if="configData.showNumber"
              class="text-h6"
            >Room: {{dept.floor}}.{{ roomNumber }}</div>
          </q-card-section>
          <q-card-section
            class="mapSection"
            clickable
            v-ripple
            v-if="configData.showFacilities"
            @click="() => {
              this.calledHelp = true
              this.styling(this.patientId, this.nextAction.time, this.patient.heartrate, this.patient.bloodpressure)
            }"
          >
            <div class="facilities">
              <div
                class="facility"
                v-for="(item, index) in facilities"
                :key="index"
              >
                <q-icon :name='"fas fa-" + item'></q-icon>
              </div>
            </div>
          </q-card-section>
          <audio
            v-if="configData.alarm && this.configData.heartrate.lower >= heartrate || heartrate >= this.configData.heartrate.upper ||
          bloodpressure <= this.configData.bloodpressure.lower || bloodpressure >= this.configData.bloodpressure.upper"
            autoplay
            loop
          >
            <source
              src="../assets/alert.wav"
              type="audio/wav"
            >
          </audio>
          <q-card-section
            class="mapSection"
            v-if="patientId > -1"
            clickable
            v-ripple
            @click="finishAction(nextAction)"
          >
            <div v-if="configData.showNextAction">
              <div class="text-h6">Next action</div>
              <div>
                <p>{{new Date(nextAction.time).toLocaleString('en-GB')}}</p>
                <p>{{nextAction.type}}</p>
              </div>
            </div>
          </q-card-section>

          <q-card-section
            class="mapSection"
            v-if="patientId === -1"
          >
            <q-btn
              id="mapAddBtn"
              round
              fab
            >
              <q-icon name="add"></q-icon>
            </q-btn>
          </q-card-section>
        </q-card>
      </div>
    </div>
  </div>
</template>

<script>
import HospitalService from '../services/HospitalService'
import ErrorService from '../services/ErrorService'

export default {
  name: 'Room',
  props: {
    roomNumber: Number,
    patientId: Number,
    facilities: Array,
    dept: Object,
    mapView: Boolean,
    x: Number,
    y: Number,
    width: Number,
    length: Number,
    configData: Object
  },
  data: () => ({
    patient: {},
    addDialog: false,
    maxId: 0,
    style: {},
    calledHelp: false,
    show: false
  }),
  created () {
    this.show = false
    this.hospitalService = new HospitalService()
    if (this.patientId === -1) {
      this.styling(-1, this.nextAction.time, this.patient.heartrate, this.patient.bloodpressure)

      ErrorService.log('Failed to load patient due to undefined index')
    } else {
      this.loadPatient(this.patientId)
      this.styling(this.patientId, this.nextAction.time, this.patient.heartrate, this.patient.bloodpressure)
    }
  },
  watch: {
    patientId (newVal) {
      this.loadPatient(newVal)
    }
  },
  methods: {
    async loadPatient (id) {
      try {
        this.sound = false
        this.style = {}
        this.patient = {}
        this.calledHelp = false
        this.patient = await this.hospitalService.getPatient(id)
        this.styling(this.patientId, this.nextAction.time, this.patient.heartrate, this.patient.bloodpressure)
      } catch {
        ErrorService.log('Failed to load patient')
      }
    },
    patientDetail (router, id, roomNumber, dept) {
      if (id > -1) {
        return router.push({ name: 'roomDetail', params: { patientId: id, roomNumber, deptName: dept.name } })
      } else {
        ErrorService.showAlert('No patient is in this room, there are no details available.')
      }
    },
    styling (patientId, actionTime, heartrate, bloodpressure) {
      this.sound = false
      let today = new Date().getTime()

      let diff = actionTime - today

      if (patientId === -1) {
        this.style = {
          backgroundColor: this.configData.free
        }
      } else {
        // patient is ok
        if (actionTime === 0) {
          this.style = {
            backgroundColor: this.configData.occupied
          }
        }
        if (Math.round(Math.floor(((diff / 1000) / 60))) > this.configData.hoursTreshold) {
          this.style = {
            backgroundColor: this.configData.occupied
          }
        }
        // action is happening within n hour(s)
        if (Math.round(Math.floor(((diff / 1000) / 60))) <= this.configData.hoursTreshold) {
          this.style = {
            backgroundColor: this.configData.warning
          }
        }

        if (actionTime < today) {
          this.style = {
            backgroundColor: this.configData.overdue
          }
        }

        if (this.calledHelp) {
          this.style = {
            backgroundColor: this.configData.emergency
          }
        }

        // EMERGENCY
        if (this.configData.heartrate.lower >= heartrate || heartrate >= this.configData.heartrate.upper ||
          bloodpressure <= this.configData.bloodpressure.lower || bloodpressure >= this.configData.bloodpressure.upper) {
          this.style = {
            backgroundColor: this.configData.emergency,
            boxShadow: '0 0 0 0 rgba(255, 82, 82, 1)',
            animation: 'emergencyPulse 2s infinite'
          }
        }
      }
    },
    async finishAction (action) {
      try {
        let patient = await this.hospitalService.getPatient(this.patientId)

        patient.actions[action.id].done = true

        await this.hospitalService.updatePatient(patient)
        this.loadPatient(patient.id)
      } catch {
        ErrorService.showAlert('Unable to finish action')
      }
    }
  },
  computed: {
    nextAction () {
      let newAction = null
      let actions = this.patient.actions
      // sort actions by datetime
      actions.sort((a, b) => {
        return new Date(a.time).getTime() - new Date(b.time).getTime()
      })

      // filter all done actions
      actions = actions.filter(action => {
        return action.done === false
      })

      newAction = actions[0]
      this.styling(this.patientId, new Date(newAction.time).getTime(), this.patient.heartrate, this.patient.bloodpressure)
      return newAction
    }
  }
}
</script>
<style lang="scss">
@keyframes emergencyPulse {
  0% {
    transform: scale(0.95);
    box-shadow: 0 0 0 0 rgba(255, 82, 82, 0.7);
  }

  70% {
    transform: scale(1);
    box-shadow: 0 0 0 10px rgba(255, 82, 82, 0);
  }

  100% {
    transform: scale(0.95);
    box-shadow: 0 0 0 0 rgba(255, 82, 82, 0);
  }
}
</style>
<style lang="css" scoped>
.listCard {
  width: 100%;
  width: 250px;
  height: 100%;
  max-height: 400px;
  margin: 10px;
  transition: background-color 1s ease;
}
.section {
  height: 125px;
}
.facilities {
  width: 100%;
  display: flex;
  justify-content: space-around;
}
.facility {
  width: -webkit-min-content;
  width: -moz-min-content;
}
#addBtn {
  margin-left: 75px;
  margin-top: 15px;
}
.container {
  display: flex;
  justify-content: space-around;
}
.hideMe {
  visibility: hidden;
}

/* map view */
.mapCard {
  transition: background-color 1s ease;
  position: absolute;
}
.mapSection {
  height: 85px;
}
#mapAddBtn {
  margin-left: 75px;
}
.blurMe {
  filter: blur(10px);
}
</style>
